#declare GroundScale = < 80, 1, 160 >;

//#declare GrayMix = T_5var_Wrinkles(1.12, color srgb 0.6, color srgb 0.65, color srgb 0.7, color srgb 0.75, color srgb 0.8)
#declare GrayPig = Pig_5colors_Wrinkles(1.12, color srgb 0.6, color srgb 0.65, color srgb 0.7, color srgb 0.75, color srgb 0.8)
#declare BrownPig = Pig_5colors_Wrinkles(1.12  ,brown1_srgb, brown2_srgb, brown3_srgb, brown4_srgb, brown5_srgb)

#declare FinalGroundPig = pigment{ gradient y pigment_map{
														[0.0 GrayPig ]
														[0.1 BrownPig ]
													}
									scale <1, 1, 1>
								}

#declare BumpsPig = pigment{ bumps color_map{ 
												[0 color srgb 0.5 ]
												[0.5 color srgb 0.75 ]
												[1.0 color srgb 0.5] }  
							scale <0.05, 0.025, 1> //The scale on 'x' and 'y' are the ones that change the 'x' and 'z' for the height field 
					}

#declare HF_Transform = 
transform{
	translate < -0.5, 0, -0.5 >
	scale GroundScale
	scale < 1, 1, 1>
}

#declare SceneGround = 
height_field{
	function 1000, 1000{
		pigment{ gradient x pigment_map{  	[0.1 BumpsPig ]
											[0.15 color srgb 0.5 ]
											[0.445 color srgb 0.5 ]
											[0.449 color srgb 0.2 ]
											[0.45 color srgb 0.1 ]
											[0.55 color srgb 0.1 ]
											[0.551 color srgb 0.2 ]
											[0.555 color srgb 0.5 ]
											[0.6 BumpsPig ]
							}
		}
	}
	smooth
	transform{ HF_Transform }
	
	texture{ pigment{FinalGroundPig } }
}

#macro PlaceGroundTile(Position)
	height_field{
		function 1000, 1000{
			pigment{ BumpsPig 
				transform{ HF_Transform inverse } 
				translate Position
			}
		}
		smooth	
		transform{ HF_Transform }
		translate Position
		texture{ T_brown2 }
	}
#end

#macro PlaceGroundTiles( X_Tile_Count, Z_Tile_Count)
	#if( 
		X_Tile_Count = 0 | Z_Tile_Count = 0 )
		#error "X or Z PlaceGroundTilesMacro parameter is equal to 0"
	#end
	#for( ItX, 0, X_Tile_Count - 1 )
		#for( ItZ, 0, Z_Tile_Count - 1 )
			#if( !( ItX = 0 & ItZ = 0 ) )
				PlaceGroundTile( < ItX * GroundScale.x, 0, ItZ * GroundScale.z > )
			#end
		#end
	#end
#end

#declare WholeGround =
union{
	object{ SceneGround }
	PlaceGroundTiles( 5, 5 )
}
